
//
// cle4vdr 2005 - 2010 by Alexander Hans <cle4vdr@arcor.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
// Or, point your browser to http://www.gnu.org/copyleft/gpl.html
//


unit uinfo;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, ComCtrls, StrUtils;
  
procedure sbm(s: String; c: Integer);
procedure sbmclear;
procedure FileChanged(b: Boolean);

procedure GetChannelCount(var c, p:Integer);
function GetChannelsInfo: String;

function isJumpMark(n: TTreeNode): Boolean;
function GetJumpIndex(n: TTreeNode): Integer;
function GetJumpIndex(s: String): Integer;

implementation

uses uinterface, uchannels;

procedure sbm(s: String; c: Integer);
begin
  if c > frmMain.sbMain.Panels.Count-1 then exit;
  frmMain.sbMain.Panels[c].Text := s;
end;

procedure sbmclear;
var
  i: Integer;
begin
  for i := 0 to frmMain.sbMain.Panels.Count - 1 do sbm('', i);
end;

procedure FileChanged(b: Boolean);
begin
  if b = true then sbm('*', 0)
  else sbm('', 0);
  frmMain.ListChanged := b;
  frmMain.RefreshTwinView;
end;

procedure GetChannelCount(var c, p:Integer);
var
  i: Integer;
begin
  c := 0;
  p := 0;
  for i := 0 to frmMain.tvMain.Items.Count - 1 do
    if isGroupSep(frmMain.tvMain.Items[i]) then inc(p);
  c := frmMain.tvMain.Items.Count - p;
end;

function GetChannelsInfo: String;
var
  c, p: Integer;
begin
  GetChannelCount(c, p);
  result := IntToStr(c) + ' Channels / ' + IntToStr(p) + ' Groups';
end;

function isJumpMark(n: TTreeNode): Boolean;
begin
  result := false;
  if (n = NIL) OR (length(n.Text) < 1) then Exit;
  if n.Text[1] = '@' then result := true;
end;

function GetJumpIndex(n: TTreeNode): Integer;
var
  dummy: String;
begin
  result := -1;
  if length(n.Text) > 1 then
  begin
    dummy := trim(copy(n.Text, 2, length(n.Text)));
    if AnsiContainsStr(dummy, ' ') then dummy := copy(dummy, 1, Pos(' ', dummy)-1);
    if dummy <> '' then
    try
      result := StrToInt(dummy);
    Except on eConvertError do Exit;
    end;
  end;
end;

function GetJumpIndex(s: String): Integer;
var
  dummy: String;
begin
  result := -1;
  if length(s) > 2 then
  begin
    dummy := trim(copy(s, 3, length(s)));
    if AnsiContainsStr(dummy, ' ') then dummy := copy(dummy, 1, Pos(' ', dummy)-1);
    if dummy <> '' then
    try
      result := StrToInt(dummy);
    Except on eConvertError do Exit;
    end;
  end;
end;


end.

