
//
// cle4vdr 2005 - 2010 by Alexander Hans <cle4vdr@arcor.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
// Or, point your browser to http://www.gnu.org/copyleft/gpl.html
//


unit uio;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Dialogs, StrUtils;
  
function ReadData(filename: String; sorted: Boolean = false): Boolean;
procedure WriteData(filename: String; oldformat: Boolean=false);


implementation

uses uinfo, uchannels, uinterface, uutils, usort;

{function DetectUTF8(uFileName: String): Boolean;
var
  tmp: TFileStream;
  signature: array[0..2] of Byte;
begin
  tmp := TFileStream.Create(uFilename, fmOpenRead);
  if tmp.Size < 2 then
  begin
    Result := False;
    tmp.Free;
    Exit;
  end;
  tmp.ReadBuffer(signature, SizeOf(signature));
  result := (signature[0] = $EF) AND (signature[1] = $BB) AND (signature[2] = $BF);
  frmMain.UseUTF8 := result;
  tmp.Free;
end;}


function ReadData(filename: String; sorted: Boolean = false): Boolean;
var
  infile: TextFile;
  dummy: String;
  i: Integer;
begin
  Try
    AssignFile(infile, filename);
    Reset(infile);
  Except
  begin
    showmessage('Could not open '+ filename);
    result := false;
    Exit;
  end;
  end;
  i := 0;
  frmMain.tvMain.BeginUpdate;
  if sorted then frmSort.SortData(@infile)
  else
  begin
    While NOT EOF(infile) do
    begin
      Readln(infile, dummy);
      dummy := trim(dummy);
      if dummy = '' then continue;
      inc(i);
      if LeftStr(dummy, 1) = ':' then AddGroupSepStr(dummy)
      else AddChannelStr(dummy);
    end;
  end;
  CloseFile(infile);
  result := true;
  RenumberChannels;
  frmMain.tvMain.EndUpdate;
  sbm(GetChannelsInfo, 1);
  sbm(filename,2);
end;

procedure WriteData(filename: String; oldformat: Boolean=false);
var
  i: Integer;
  outfile: TextFile;
begin
  AssignFile(outfile, filename);
  Rewrite(outfile);
  For i := 0 to frmMain.tvMain.Items.Count-1 do
  begin
    if isGroupSep(frmMain.tvMain.Items[i]) then Writeln(outfile, GetProviderStr(frmMain.tvMain.Items[i]))
    else Writeln(outfile, GetChannelStr(frmMain.tvMain.Items[i], oldformat));
  end;
  CloseFile(outfile);
  FileChanged(false);
end;

end.

