
//
// cle4vdr 2005 - 2010 by Alexander Hans <cle4vdr@arcor.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
// Or, point your browser to http://www.gnu.org/copyleft/gpl.html
//


unit usearch;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, uinterface, uchannels, StrUtils;

type

  { TfrmSearch }

  TfrmSearch = class(TForm)
    btSearchOk: TButton;
    btSearchCancel: TButton;
    edSearch: TEdit;
    lbSearch: TLabel;
    Panel1: TPanel;
    rgStart: TRadioGroup;
    rgMatch: TRadioGroup;
    rgIn: TRadioGroup;
    procedure btSearchCancelClick(Sender: TObject);
    procedure btSearchOkClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SearchFor(s: String; r: Integer);
  private
    { private declarations }
  public
    SearchTree: TTreeView;
    { public declarations }
  end; 

var
  frmSearch: TfrmSearch;

implementation

{ TfrmSearch }

procedure TfrmSearch.FormActivate(Sender: TObject);
begin
  edSearch.SetFocus;
  edSearch.SelectAll;
end;

procedure TfrmSearch.btSearchCancelClick(Sender: TObject);
begin
  frmSearch.Close;
end;

procedure TfrmSearch.btSearchOkClick(Sender: TObject);
begin
  frmSearch.Close;
  frmSearch.Hide;
  SearchFor(edSearch.Text, rgIn.ItemIndex);
end;


procedure TfrmSearch.SearchFor(s: String; r: Integer);
var
  sstr: String;
  n: TTreeNode;
  cp: clep;
  found: Boolean;
begin
  case rgStart.ItemIndex of
    0: n := SearchTree.Items[0];
    1: if SearchTree.Selected <> NIL then n := SearchTree.Selected else n := SearchTree.Items[0];
  end;
  while n <> NIL do
  begin
    if SearchTree = frmMain.tvTwin then cp := clep(TTreeNode(n.Data).Data) else
                                        cp := clep(n.Data);
    Case r of
      0: sstr := cp^.Name;
      1: sstr := clep(n.Data)^.Short;
      2: sstr := clep(n.Data)^.Provider;
      3: sstr := clep(n.Data)^.Source;
      4: sstr := clep(n.Data)^.Frequency;
      5: sstr := clep(n.Data)^.Symbolrate;
      6: sstr := clep(n.Data)^.Sid;
      7: sstr := clep(n.Data)^.Nid;
      8: sstr := clep(n.Data)^.Tid;
      9: sstr := clep(n.Data)^.Rid;
     10: sstr := ChannelID(n);
    end;
    case rgMatch.ItemIndex of
      0: found := sstr = s;
      1: found := AnsiContainsText(sstr, s);
      2: found := AnsiContainsStr(sstr, s);
    end;
    if found = true then
    begin
      SearchTree.Selected := n;
      SearchTree.Selected.MakeVisible;
      if Application.MessageBox(PChar('Found at ' + IntToStr(n.AbsoluteIndex) + ' (Channel '+ Inttostr(clep(n.Data)^.Number) + ') - Search again?'), 'Searching ...', 1) <> 1 then Exit;
    end;
    n := n.GetNext;
  end;
  showmessage('No (other) entries ...');
end;


initialization
  {$I usearch.lrs}

end.

